| Flutter Impeller |

Public Member Functions | List of all members
impeller::ArcGeometry Class Referencefinal

`#include <arc_geometry.h>`

Inheritance diagram for impeller::ArcGeometry:

## Public Member Functions
| ArcGeometry (const Arc &arc)
| ArcGeometry (const Arc &arc, const StrokeParameters &stroke)
| ~ArcGeometry () override
bool | CoversArea (const Matrix &transform, const Rect &rect) const override
| Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`. More...
bool | IsAxisAlignedRect () const override
Scalar | ComputeAlphaCoverage (const Matrix &transform) const override
Public Member Functions inherited from impeller::Geometry
virtual | ~Geometry ()
virtual GeometryResult::Mode | GetResultMode () const
virtual bool | CanApplyMaskFilter () const

## Additional Inherited Members
Static Public Member Functions inherited from impeller::Geometry
static std::unique_ptr< Geometry > | MakeFillPath (const flutter::DlPath &path, std::optional< Rect > inner_rect=std::nullopt)
static std::unique_ptr< Geometry > | MakeStrokePath (const flutter::DlPath &path, const StrokeParameters &stroke={})
static std::unique_ptr< Geometry > | MakeCover ()
static std::unique_ptr< Geometry > | MakeRect (const Rect &rect)
static std::unique_ptr< Geometry > | MakeOval (const Rect &rect)
static std::unique_ptr< Geometry > | MakeLine (const Point &p0, const Point &p1, const StrokeParameters &stroke)
static std::unique_ptr< Geometry > | MakeCircle (const Point &center, Scalar radius)
static std::unique_ptr< Geometry > | MakeStrokedCircle (const Point &center, Scalar radius, Scalar stroke_width)
static std::unique_ptr< Geometry > | MakeFilledArc (const Rect &oval_bounds, Degrees start, Degrees sweep, bool include_center)
static std::unique_ptr< Geometry > | MakeStrokedArc (const Rect &oval_bounds, Degrees start, Degrees sweep, const StrokeParameters &stroke)
static std::unique_ptr< Geometry > | MakeRoundRect (const Rect &rect, const Size &radii)
static std::unique_ptr< Geometry > | MakeRoundSuperellipse (const Rect &rect, Scalar corner_radius)
static Scalar | ComputeStrokeAlphaCoverage (const Matrix &entity, Scalar stroke_width)
| Compute an alpha value to simulate lower coverage of fractional pixel strokes. More...
static GeometryResult | ComputePositionGeometry (const ContentContext &renderer, const Tessellator::VertexGenerator &generator, const Entity &entity, RenderPass &pass)

## Detailed Description

Definition at line 17 of file arc_geometry.h.

## Constructor & Destructor Documentation

## ◆ ArcGeometry() [1/2]

impeller::ArcGeometry::ArcGeometry | ( | const Arc & | arc | ) |
| explicit

Definition at line 11 of file arc_geometry.cc.

12 : arc_(arc), stroke_width_(-1.0f), cap_(Cap::kButt) {}
impeller::Cap::kButt
@ kButt

References impeller::kButt.

## ◆ ArcGeometry() [2/2]

impeller::ArcGeometry::ArcGeometry | ( | const Arc & | arc,
|  | const StrokeParameters & | stroke
| ) |  |
| explicit

Definition at line 14 of file arc_geometry.cc.

15 : arc_(arc), stroke_width_(stroke.width), cap_(stroke.cap) {
16 FML_DCHECK(arc.IsPerfectCircle());
17 FML_DCHECK(!arc.IncludeCenter());
18 }

References impeller::Arc::IncludeCenter(), and impeller::Arc::IsPerfectCircle().

## ◆ ~ArcGeometry()

impeller::ArcGeometry::~ArcGeometry | ( |  | ) |
| overridedefault

## Member Function Documentation

## ◆ ComputeAlphaCoverage()

Scalar impeller::ArcGeometry::ComputeAlphaCoverage | ( | const Matrix & | transform | ) | const
| overridevirtual

Reimplemented from impeller::Geometry.

Definition at line 23 of file arc_geometry.cc.

23 {
24 if (stroke_width_ < 0) {
25 return 1;
26 }
27 return Geometry::ComputeStrokeAlphaCoverage(transform, stroke_width_);
28 }
impeller::Geometry::ComputeStrokeAlphaCoverage
static Scalar ComputeStrokeAlphaCoverage(const Matrix &entity, Scalar stroke_width)
Compute an alpha value to simulate lower coverage of fractional pixel strokes.
Definition: geometry.cc:149
transform
Matrix transform
Definition: gaussian_blur_filter_contents.cc:214

References impeller::Geometry::ComputeStrokeAlphaCoverage(), and transform.

## ◆ CoversArea()

bool impeller::ArcGeometry::CoversArea | ( | const Matrix & | transform,
|  | const Rect & | rect
| ) |  | const
| overridevirtual

Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`.

This is a conservative estimate useful for certain optimizations.

Returns
  `true` if the transformed geometry is guaranteed to cover the given `rect`. May return `false` in many undetected cases where the transformed geometry does in fact cover the `rect`.

Reimplemented from impeller::Geometry.

Definition at line 75 of file arc_geometry.cc.

75 {
76 return false;
77 }

## ◆ IsAxisAlignedRect()

bool impeller::ArcGeometry::IsAxisAlignedRect | ( |  | ) | const
| overridevirtual

Reimplemented from impeller::Geometry.

Definition at line 79 of file arc_geometry.cc.

79 {
80 return false;
81 }

The documentation for this class was generated from the following files:

- impeller/entity/geometry/arc_geometry.h
- impeller/entity/geometry/arc_geometry.cc